﻿-- Objective Cleanup
function TGTradeS:Cleanup()

  local frame, events = CreateFrame("Frame"), {}

  frame:SetScript("OnEvent",
    function(self, event, ...)
      events[event](self, ...)
    end
  )

  frame:SetScript("OnUpdate",
    function(LastUpdate)
      if not (TGTradeS.db.char.guide == TourGuide.db.char.currentguide) then
        --print("Guide Changed!");
        TGTradeS.db.char.guide = TourGuide.db.char.currentguide;

        -- Cleanup
        for i, t in ipairs(TourGuide.tags) do
          local done = false
          -- Cleanup level opjectives that is done
          if (t:match("|LVL|(%d+)|")) then
            lvl = tonumber(t:match("|LVL|(%d+)|"))
            if lvl and lvl <= UnitLevel("Player") then TourGuide:SetTurnedIn(i, true, true) end
            done = true
          end
          
          -- Cleanup skills
          if (not done) and (t:match("|SKILL|(.+)|")) then
            -- Get Skill info to check
            local info = { strsplit(",", t:match("|SKILL|(.+)|")) }
            local numDone = 0
            
            for infoIndex = 1, #info, 1 do
              if strlen(strtrim(info[infoIndex])) > 0 then
                local SkillName, SkillLevel = info[infoIndex]:match("([%a:%s]+)%s?(%d+)");
                SkillName = strtrim(SkillName);
                SkillLevel = tonumber(SkillLevel) or 1;

                -- Loop all curent skill and check if the skill match
                for _, sID in ipairs(TGTradeS:GetProfessions()) do
                  if sID then
                    local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)
                    if SkillName == sName and SkillLevel <= tonumber(sLevel) then
                      numDone = numDone + 1
                    end
                  end
                end
              -- ensure that it will complete even that there is a , to mutch
              else
                numDone = numDone + 1
              end
            end
            
            if numDone >= #info then
              TourGuide:SetTurnedIn(i, true, true);
              done = true
            end
          end

          -- Cleanup level to skills
          if (not done) and (t:match("|LVLTOSKILL|([%a:%s]+)%s?(%d*)|")) then
            -- Get Skill info to check
            local _, _, SkillName, SkillLevel = t:find("|LVLTOSKILL|([%a:%s]+)%s?(%d*)|");
            SkillName = strtrim(SkillName);
            SkillLevel = tonumber(SkillLevel) or 1;

            -- Loop all curent skill and check if the skill match
            local skills = TGTradeS:GetProfessions();
            for _, sID in ipairs(skills) do
              if sID then
                local sName, _, sLevel, _, _, _, _, _ = GetProfessionInfo(sID)

                if SkillName == strtrim(sName) and SkillLevel <= tonumber(sLevel) then
                  TourGuide:SetTurnedIn(i, true, true);
                  done = true
                end
              end
            end
          end

          -- Cleanup Tradeskill
          if (not done) and t:match("|TRAINSKILL|([%a:%s]+)%s?(%d*)|") then
            -- Get Skill info to check
            local _, _, SkillName, MaxSkillLevel = t:find("|TRAINSKILL|([%a:%s]+)%s?(%d*)|");
            SkillName = strtrim(SkillName);
            MaxSkillLevel = tonumber(MaxSkillLevel) or 75;

            -- Loop all curent skill and check if the skill match
            local skills = TGTradeS:GetProfessions();
            for _, sID in ipairs(skills) do
              if sID then
                local sName, _, _, maxSLevel, _, _, _, _ = GetProfessionInfo(sID)
                if SkillName == strtrim(sName) and MaxSkillLevel <= tonumber(maxSLevel) then
                  TourGuide:SetTurnedIn(i, true, true);
                  done = true
                end
              end
            end
          end
        end
        -- print("Guide Cleanup Done");
      end
    end
  )

  for k, v in pairs(events) do
    frame:RegisterEvent(k)
  end
end